var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { Spinner } from '../../elements/loaders';
import List, { ListItem, ListItemIcon, ListItemText, ListSubheader } from 'material-ui/List';
import Avatar from 'material-ui/Avatar';
import IconButton from 'material-ui/IconButton';
import TenantAncestryList from '../../helpers/tenant_ancestry';

var TenantItem = function TenantItem(_ref, tenantClicked, tenantActive, subTenantListClick) {
  var id = _ref.id,
      name = _ref.name,
      _ref$description = _ref.description,
      description = _ref$description === undefined ? 'Tenant Description' : _ref$description,
      children = _ref.children;
  return React.createElement(
    'div',
    { key: id, className: tenantActive ? 'tenant-list-item active' : 'tenant-list-item' },
    React.createElement(
      ListItem,
      { onClick: tenantClicked },
      React.createElement(Avatar, { alt: 'Remy Sharp', src: 'https://i.imgur.com/zQA3Cck.png' }),
      React.createElement(ListItemText, { className: 'organization--label', primary: name, secondary: description })
    ),
    children && React.createElement(
      IconButton,
      { 'aria-label': 'Sub Tenants', onClick: subTenantListClick },
      React.createElement(
        'i',
        { className: 'material-icons' },
        'chevron_right'
      )
    )
  );
};

var TenantList = function (_React$PureComponent) {
  _inherits(TenantList, _React$PureComponent);

  function TenantList() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, TenantList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = TenantList.__proto__ || Object.getPrototypeOf(TenantList)).call.apply(_ref2, [this].concat(args))), _this), Object.defineProperty(_this, 'renderTenants', {
      enumerable: true,
      writable: true,
      value: function value() {
        var _this$props = _this.props,
            activeTenant = _this$props.activeTenant,
            parentTenant = _this$props.parentTenant,
            selectTenant = _this$props.selectTenant,
            subTenantListClicked = _this$props.subTenantListClicked,
            tenantLookupTable = _this$props.tenantLookupTable;

        var listedTenantIds = parentTenant === null ? tenantLookupTable.topLevel : tenantLookupTable[parentTenant].children;

        return listedTenantIds.map(function (tenant_id, index) {
          return TenantItem(tenantLookupTable[tenant_id], selectTenant(tenantLookupTable[tenant_id]), activeTenant.id === tenantLookupTable[tenant_id].id, subTenantListClicked(tenantLookupTable[tenant_id].id));
        });
      }
    }), Object.defineProperty(_this, 'tenantParentHeader', {
      enumerable: true,
      writable: true,
      value: function value(_ref3) {
        var parentTenant = _ref3.parentTenant,
            tenantLookupTable = _ref3.tenantLookupTable,
            paginateBack = _ref3.paginateBack;

        return React.createElement(
          'div',
          { className: parentTenant === null ? 'hidden' : 'tenant__list-nav-header' },
          React.createElement(
            IconButton,
            { 'aria-label': 'Go Back', className: 'page-back-button', onClick: paginateBack },
            React.createElement(
              'i',
              { className: 'material-icons' },
              'chevron_left'
            )
          ),
          React.createElement(
            'span',
            null,
            TenantAncestryList(parentTenant, tenantLookupTable).join(' < ')
          )
        );
      }
    }), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TenantList, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          tenantSyncedWithDB = _props.tenantSyncedWithDB;

      var tenantListClass = active ? 'tenant__list_wrapper' : 'tenant__list_wrapper hidden';
      return React.createElement(
        'div',
        { className: tenantListClass },
        React.createElement(
          List,
          { subheader: React.createElement(
              'li',
              { className: 'tenant-list__heading' },
              ' SWITCH TENANT'
            ) },
          this.tenantParentHeader(this.props),
          this.renderTenants()
        ),
        React.createElement(
          'div',
          { className: tenantSyncedWithDB === true ? 'hidden' : 'loader-spinner-wrapper' },
          React.createElement(Spinner, null)
        )
      );
    }
  }]);

  return TenantList;
}(React.PureComponent);

export default TenantList;