import { NOT_DEFINED } from '../constants/type_constants';

var TenantIndex = function TenantIndex(tenants) {
  return tenants.reduce(function (lookup, tenant, i) {
    lookup[tenant.id] = tenant;
    return lookup;
  }, { topLevel: [] });
};

var TenantLookup = function TenantLookup(tenants) {

  return tenants.reduce(function (lookup, tenant, i) {
    if (tenant.parent_id === null) {
      lookup.topLevel.push(tenant.id);
      return lookup;
    }
    if (lookup[tenant.parent_id].children === NOT_DEFINED) {
      lookup[tenant.parent_id].children = [];
    }
    lookup[tenant.parent_id].children.push(tenant.id);
    return lookup;
  }, TenantIndex(tenants));
};

export default TenantLookup;