import React from 'react';
import ReactOnRails from 'react-on-rails';
import { Provider } from 'react-redux';

import Layout from './containers/layout';
import CortexStore from './store/store';

ReactOnRails.registerStore({
  CortexStore: CortexStore
});

var CortexApp = function CortexApp(props, railsContext) {
  var store = ReactOnRails.getStore('CortexStore');
  return React.createElement(
    Provider,
    { store: store },
    React.createElement(Layout, { temporary_render: props.temporary_render })
  );
};

ReactOnRails.register({ CortexApp: CortexApp });