var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { UPDATE_ORGANIZATION_SCOPE, TOGGLE_TENANT_SWITCHER, SELECT_TENANT, TENANT_UPDATED, SUBLIST_CLICKED, TENANT_UPDATE_ERROR, TOGGLE_SIDEBAR, PAGINATE_BACK } from '../constants/tenant_switcher';

var tenantSwitcherReducer = function tenantSwitcherReducer(_ref) {
  var active_tenant = _ref.active_tenant,
      csrf_token = _ref.csrf_token,
      sidebarExpanded = _ref.sidebarExpanded,
      tenants = _ref.tenants,
      current_user = _ref.current_user,
      environment = _ref.environment,
      environment_abbreviated = _ref.environment_abbreviated;

  var initialState = {
    tenantListActive: false,
    activeTenant: active_tenant,
    parentTenant: active_tenant.parent_id,
    tenantSyncedWithDB: true,
    csrf_token: csrf_token,
    sidebarExpanded: sidebarExpanded,
    tenants: tenants,
    currentUser: current_user,
    environment: environment,
    environment_abbreviated: environment_abbreviated
  };
  return function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
      case PAGINATE_BACK:
        return _extends({}, state, {
          parentTenant: action.payload
        });
      case SELECT_TENANT:
        return _extends({}, state, {
          activeTenant: action.payload,
          tenantSyncedWithDB: state.activeTenant.id === action.payload.id
        });
      case TENANT_UPDATED:
        return _extends({}, state, {
          currentUser: action.payload,
          parentTenant: action.payload.active_tenant.parent_id,
          tenantSyncedWithDB: true,
          tenantListActive: false
        });
      case SUBLIST_CLICKED:
        return _extends({}, state, {
          parentTenant: action.payload
        });
      case TENANT_UPDATE_ERROR:
        return _extends({}, state, {
          activeTenant: state.active_tenant
        });
      case TOGGLE_SIDEBAR:
        return _extends({}, state, {
          sidebarExpanded: !state.sidebarExpanded,
          tenantListActive: false
        });
      case TOGGLE_TENANT_SWITCHER:
        return _extends({}, state, {
          tenantListActive: !state.tenantListActive,
          parentTenant: state.activeTenant.parent_id
        });
      default:
        return state;
    }
  };
};

export default tenantSwitcherReducer;